//+------------------------------------------------------------------+
//|                                         Hull_Variation_RB_EA.mq4 |
//|                            Rogrio Borges, Copyright 2016        |
//|                                          rogeriob28@gmail.com    | 
//+------------------------------------------------------------------+
#property copyright "Rogrio Borges,Copyright 2016"
#property link      "rogeriob28@gmail.com"

extern string Comentario = "Hull Variation EA v1 ";
extern string S1="----Hull Variation Entry Settings";
extern int    HMAPeriod       = 27;
extern int    HMAPrice        = PRICE_CLOSE;
extern double HMADivisor      = 1.5;


extern int MagicNumber=10001;
extern double Lots =1;
extern int Slippage=1;
extern int Start_Time=0;
extern int Finish_Time=0;




//+------------------------------------------------------------------+
//    expert start function
//+------------------------------------------------------------------+
int start()
{

//Entry_Logic
      //Culclate Indicator

int barToTest = 1; // Or use 0 for a still opened bar

double hull_trend_current = iCustom(NULL,0,"Hull variation 2","", HMAPeriod,HMAPrice,HMADivisor,3,barToTest);
double hull_trend_previous = iCustom(NULL,0,"Hull variation 2","", HMAPeriod,HMAPrice,HMADivisor,3,barToTest+1);
Comment("hull_trend_current= ",hull_trend_current," hull_trend_previous= ",hull_trend_previous," barToTest= ",barToTest);  
     

// Buy and Sell Close Condition   
 for(int index=OrdersTotal()-1; index>=0; index--)
   {
   OrderSelect(index,SELECT_BY_POS,MODE_TRADES);
   if((OrderSymbol()==Symbol()) && (OrderMagicNumber()==MagicNumber))
   {
 
    if(OrderType()==OP_BUY && hull_trend_current == -1)
   {
      OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),Slippage,Green);
   }
   
   if(OrderType()==OP_SELL && hull_trend_current ==  1)
   {
      OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),Slippage,Orange);
   }
   }
   }


// Buy and Sell Open 
  double MyPoint=Point;
  if(Digits==3 || Digits==5) MyPoint=Point*10;

  if(TotalOrdersCount()==0 && AllowTradesByTime()==True) 
  {
     int result=0;
  //   open order only if trend changes   
  if (hull_trend_current != hull_trend_previous)
  {      
     if (hull_trend_current ==  1) // Here is your open buy rule
     {
        result=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,0,0,Comentario,MagicNumber,0,Blue);
        
     }
     
     if (hull_trend_current ==  -1) // Here is your open Sell rule
     {
        result=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,0,0,Comentario,MagicNumber,0,Red);
        
    }
    }
  }
  return(0);
}


// Hour to Trade
bool AllowTradesByTime()
   {
      int Current_Time = TimeHour(TimeCurrent());
   if (Start_Time == 0) Start_Time = 24; if (Finish_Time == 0) Finish_Time = 24; if (Current_Time == 0) Current_Time = 24;
      
   if ( Start_Time < Finish_Time )
      if ( (Current_Time < Start_Time) || (Current_Time >= Finish_Time) ) return(false);
      
   if ( Start_Time > Finish_Time )
      if ( (Current_Time < Start_Time) && (Current_Time >= Finish_Time) ) return(false);
      
   return(true);
   }

// Total Orders
int TotalOrdersCount()
{
  int result=0;
  for(int i=0;i<OrdersTotal();i++)
  {
     if(OrderSelect(i,SELECT_BY_POS ,MODE_TRADES))
     {
      if (OrderMagicNumber()==MagicNumber && OrderSymbol()==Symbol()) result++;
     }
  }
  return (result);
}

